--[[
	Copyright (C) Udorn (Blackhand)
--]]

qmstr = qmstr or {}

qmstr.Config = qmstr.QuestMaster:NewModule("Config", "AceEvent-3.0")
local L = qmstr.Locale.GetInstance()
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")

local APP_NAME = "QuestMaster"

local log = vendor.Debug:new("Config")

local self = qmstr.Config

-- quest filter types
qmstr.Config.FILTER_OFF = 1
qmstr.Config.FILTER_ZONE = 2
qmstr.Config.FILTER_WATCH = 3
qmstr.Config.FILTER_WATCH_OR_ZONE = 4

qmstr.Config.DEFAULT_CONFIG = {
	profile = {
		questCompleteSound = "SOUND-UI_AutoQuestComplete"
	}
}

local function _NextOrder()
	local order = self.nextOrder or 1
	self.nextOrder = order + 1
	return order
end

local function _InitOpts(self)
	self.opts = {
    	type = "group",
    	childGroups = "tab",
      	args = {
			questCompleteSound = {
				type = "select",
				order = _NextOrder(),
				name = L["Quest complete sound"],
				desc = L["Sound played when completing a quest."],
				values = {
					[""] = L["-None-"],
					["SOUND-QUESTCOMPLETED"] = L["Quest completed"],
					["SOUND-UI_AutoQuestComplete"] = L["Quest completed2"],
					["Sound\\Creature\\Peon\\PeonBuildingComplete1.wav"] = L["Work complete!"],
				},
				set = function(info, value) self.profile.questCompleteSound = value; qmstr.QuestMaster:PlaySound()  end,
				get = function() return self.profile.questCompleteSound end,
			},
        	profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(qmstr.QuestMaster.db)
      	}
    }
end

function qmstr.Config:OnInitialize()
	self.db = qmstr.QuestMaster.db
	self.profile = self.db.profile
	
	_InitOpts(self)
	
	AceConfig:RegisterOptionsTable(APP_NAME, self.opts)
	self.configFrame = AceConfigDialog:AddToBlizOptions(APP_NAME)
	qmstr.QuestMaster:RegisterChatCommand("questmaster", "ChatCommand")

	self.db.RegisterCallback(self, "OnProfileChanged", "Reset")
	self.db.RegisterCallback(self, "OnProfileCopied", "Reset")
	self.db.RegisterCallback(self, "OnProfileReset", "Reset")
end

function qmstr.Config:Reset()
	--qmstr.QuestMaster:Reset()
end

function qmstr.Config:ToogleConfigDialog()
	log:Debug("Toggle")
	InterfaceOptionsFrame_OpenToCategory(self.configFrame)
end