--[[
	Copyright (C) Udorn (Blackhand)
--]]

qmstr = qmstr or {}

qmstr.QuestMaster = LibStub("AceAddon-3.0"):NewAddon("QuestMaster", "AceEvent-3.0", "AceConsole-3.0")
local L = qmstr.Locale.GetInstance()
local log = vendor.Debug:new("QuestMaster")

local function _FetchNumCompletedQuests(self)
	local numEntries, numQuests = GetNumQuestLogEntries()
	local completedQuests = self.completedQuests
	local numCompletedQuests = 0
	for i=1,numEntries do
		local title, level, suggestedGroup, isHeader, isCollapsed, isComplete, frequency, questID, startEvent, displayQuestID, isOnMap, hasLocalPOI, isTask, isStory = GetQuestLogTitle(i)
		log:Debug("entry: %s questTitle: %s isComplete: %s questID: %s", i, title, isComplete, questID)
        if (isComplete and not completedQuests[questID]) then
            completedQuests[questID] = true
            numCompletedQuests = numCompletedQuests + 1
        end
	end
	log:Debug("_FetchCompletedQuests numEntries: %s numQuests: %s completed: %s", numEntries, numQuests, numCompletedQuests)
	return numCompletedQuests
end

function qmstr.QuestMaster:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("QuestMasterDb", qmstr.Config.DEFAULT_CONFIG, "Default")
end

function qmstr.QuestMaster:OnEnable()
	log:Debug("OnEnable")
	self.completedQuests = {}
	self:RegisterEvent("UNIT_QUEST_LOG_CHANGED")
	_FetchNumCompletedQuests(self)
end

function qmstr.QuestMaster:UNIT_QUEST_LOG_CHANGED()
	log:Debug("UNIT_QUEST_LOG_CHANGED")
	if (_FetchNumCompletedQuests(self) > 0) then
		self:PlaySound()
	end
end

function qmstr.QuestMaster:PlaySound()
	log:Debug("PlaySound")
	local sound = self.db.profile.questCompleteSound
	if (strlen(sound) > 0) then
		if (string.find(sound, "SOUND-") == 1) then
			log:Debug("sub [%s]", string.sub(sound, 7))
			PlaySound(string.sub(sound, 7))
		else
			PlaySoundFile(sound)
		end
	end
end

function qmstr.QuestMaster:ChatCommand(msg)
	log:Debug("msg [%s]", msg)
	qmstr.Config:ToogleConfigDialog()
--	InterfaceOptionsFrame_OpenToCategory(self.configFrame)
end